Open CASCADE Technology  7.5.0
Public Member Functions
BRepOffsetAPI_MakeEvolved Class Reference

Describes functions to build evolved shapes. An evolved shape is built from a planar spine (face or wire) and a profile (wire). The evolved shape is the unlooped sweep (pipe) of the profile along the spine. Self-intersections are removed. A MakeEvolved object provides a framework for: More...

#include <BRepOffsetAPI_MakeEvolved.hxx>

Inheritance diagram for BRepOffsetAPI_MakeEvolved:
Inheritance graph
[legend]

Public Member Functions

 BRepOffsetAPI_MakeEvolved ()
 
 BRepOffsetAPI_MakeEvolved (const TopoDS_Shape &theSpine, const TopoDS_Wire &theProfile, const GeomAbs_JoinType theJoinType=GeomAbs_Arc, const Standard_Boolean theIsAxeProf=Standard_True, const Standard_Boolean theIsSolid=Standard_False, const Standard_Boolean theIsProfOnSpine=Standard_False, const Standard_Real theTol=0.0000001, const Standard_Boolean theIsVolume=Standard_False, const Standard_Boolean theRunInParallel=Standard_False)
 Constructs an evolved shape by sweeping the profile (theProfile) along the spine (theSpine). theSpine can be shape only of type wire or face. See description to this class for detailed information. More...
 
const BRepFill_EvolvedEvolved () const
 
virtual void Build () override
 Builds the resulting shape (redefined from MakeShape). More...
 
const TopTools_ListOfShapeGeneratedShapes (const TopoDS_Shape &SpineShape, const TopoDS_Shape &ProfShape) const
 Returns the shapes created from a subshape <SpineShape> of the spine and a subshape <ProfShape> on the profile. More...
 
const TopoDS_ShapeTop () const
 Return the face Top if <Solid> is True in the constructor. More...
 
const TopoDS_ShapeBottom () const
 Return the face Bottom if <Solid> is True in the constructor. More...
 
- Public Member Functions inherited from BRepBuilderAPI_MakeShape
virtual const TopoDS_ShapeShape ()
 Returns a shape built by the shape construction algorithm. Raises exception StdFail_NotDone if the shape was not built. More...
 
 operator TopoDS_Shape ()
 
virtual const TopTools_ListOfShapeGenerated (const TopoDS_Shape &S)
 Returns the list of shapes generated from the shape <S>. More...
 
virtual const TopTools_ListOfShapeModified (const TopoDS_Shape &S)
 Returns the list of shapes modified from the shape <S>. More...
 
virtual Standard_Boolean IsDeleted (const TopoDS_Shape &S)
 Returns true if the shape S has been deleted. More...
 
- Public Member Functions inherited from BRepBuilderAPI_Command
virtual ~BRepBuilderAPI_Command ()
 
virtual Standard_Boolean IsDone () const
 
void Check () const
 Raises NotDone if done is false. More...
 

Additional Inherited Members

- Protected Member Functions inherited from BRepBuilderAPI_MakeShape
 BRepBuilderAPI_MakeShape ()
 
- Protected Member Functions inherited from BRepBuilderAPI_Command
 BRepBuilderAPI_Command ()
 Set done to False. More...
 
void Done ()
 Set done to true. More...
 
void NotDone ()
 Set done to false. More...
 
- Protected Attributes inherited from BRepBuilderAPI_MakeShape
TopoDS_Shape myShape
 
TopTools_ListOfShape myGenerated
 

Detailed Description

Describes functions to build evolved shapes. An evolved shape is built from a planar spine (face or wire) and a profile (wire). The evolved shape is the unlooped sweep (pipe) of the profile along the spine. Self-intersections are removed. A MakeEvolved object provides a framework for:

The Profile is expected to be planar and can be a line (which lies in infinite number of planes).

The profile is defined in a Referential R. The position of the profile at the current point of the spine is given by confusing R and the local referential given by ( D0, D1 and the normal of the Spine).

The coordinate system is determined by theIsAxeProf argument:

theJoinType defines the type of pipe generated by the salient vertices of the spine. The default type is GeomAbs_Arc where the vertices generate revolved pipes about the axis passing along the vertex and the normal to the plane of the spine. At present, this is the only construction type implemented.

if <theIsSolid> is TRUE the Shape result is completed to be a solid or a compound of solids.

If theIsProfOnSpine == TRUE then the profile must connect with the spine.

If theIsVolume option is switched on then self-intersections in the result of Pipe-algorithm will be removed by BOPAlgo_MakerVolume algorithm. At that the arguments "theJoinType", "theIsAxeProf", "theIsProfOnSpine" are not used.

Constructor & Destructor Documentation

◆ BRepOffsetAPI_MakeEvolved() [1/2]

BRepOffsetAPI_MakeEvolved::BRepOffsetAPI_MakeEvolved ( )

◆ BRepOffsetAPI_MakeEvolved() [2/2]

BRepOffsetAPI_MakeEvolved::BRepOffsetAPI_MakeEvolved ( const TopoDS_Shape theSpine,
const TopoDS_Wire theProfile,
const GeomAbs_JoinType  theJoinType = GeomAbs_Arc,
const Standard_Boolean  theIsAxeProf = Standard_True,
const Standard_Boolean  theIsSolid = Standard_False,
const Standard_Boolean  theIsProfOnSpine = Standard_False,
const Standard_Real  theTol = 0.0000001,
const Standard_Boolean  theIsVolume = Standard_False,
const Standard_Boolean  theRunInParallel = Standard_False 
)

Constructs an evolved shape by sweeping the profile (theProfile) along the spine (theSpine). theSpine can be shape only of type wire or face. See description to this class for detailed information.

Member Function Documentation

◆ Bottom()

const TopoDS_Shape& BRepOffsetAPI_MakeEvolved::Bottom ( ) const

Return the face Bottom if <Solid> is True in the constructor.

◆ Build()

virtual void BRepOffsetAPI_MakeEvolved::Build ( )
overridevirtual

Builds the resulting shape (redefined from MakeShape).

Reimplemented from BRepBuilderAPI_MakeShape.

◆ Evolved()

const BRepFill_Evolved& BRepOffsetAPI_MakeEvolved::Evolved ( ) const

◆ GeneratedShapes()

const TopTools_ListOfShape& BRepOffsetAPI_MakeEvolved::GeneratedShapes ( const TopoDS_Shape SpineShape,
const TopoDS_Shape ProfShape 
) const

Returns the shapes created from a subshape <SpineShape> of the spine and a subshape <ProfShape> on the profile.

◆ Top()

const TopoDS_Shape& BRepOffsetAPI_MakeEvolved::Top ( ) const

Return the face Top if <Solid> is True in the constructor.


The documentation for this class was generated from the following file: